# CustomHbondForce Class Reference

This class supports a wide variety of energy functions used to represent hydrogen bonding. More...

Inheritance diagram for CustomHbondForce:

List of all members.

## Public Member Functions
def | __del__
| __del__(OpenMM.CustomHbondForce self)
def | getNumDonors
| getNumDonors(CustomHbondForce self) -> int
def | getNumAcceptors
| getNumAcceptors(CustomHbondForce self) -> int
def | getNumExclusions
| getNumExclusions(CustomHbondForce self) -> int
def | getNumPerDonorParameters
| getNumPerDonorParameters(CustomHbondForce self) -> int
def | getNumPerAcceptorParameters
| getNumPerAcceptorParameters(CustomHbondForce self) -> int
def | getNumGlobalParameters
| getNumGlobalParameters(CustomHbondForce self) -> int
def | getNumTabulatedFunctions
| getNumTabulatedFunctions(CustomHbondForce self) -> int
def | getNumFunctions
| getNumFunctions(CustomHbondForce self) -> int
def | getEnergyFunction
| getEnergyFunction(CustomHbondForce self) -> std.string const &
def | setEnergyFunction
| setEnergyFunction(CustomHbondForce self, std.string const & energy)
def | getNonbondedMethod
| getNonbondedMethod(CustomHbondForce self) -> OpenMM.CustomHbondForce.NonbondedMethod
def | setNonbondedMethod
| setNonbondedMethod(CustomHbondForce self, OpenMM.CustomHbondForce.NonbondedMethod method)
def | getCutoffDistance
| getCutoffDistance(CustomHbondForce self) -> double
def | setCutoffDistance
| setCutoffDistance(CustomHbondForce self, double distance)
def | addPerDonorParameter
| addPerDonorParameter(CustomHbondForce self, std.string const & name) -> int
def | getPerDonorParameterName
| getPerDonorParameterName(CustomHbondForce self, int index) -> std.string const &
def | setPerDonorParameterName
| setPerDonorParameterName(CustomHbondForce self, int index, std.string const & name)
def | addPerAcceptorParameter
| addPerAcceptorParameter(CustomHbondForce self, std.string const & name) -> int
def | getPerAcceptorParameterName
| getPerAcceptorParameterName(CustomHbondForce self, int index) -> std.string const &
def | setPerAcceptorParameterName
| setPerAcceptorParameterName(CustomHbondForce self, int index, std.string const & name)
def | addGlobalParameter
| addGlobalParameter(CustomHbondForce self, std.string const & name, double defaultValue) -> int
def | getGlobalParameterName
| getGlobalParameterName(CustomHbondForce self, int index) -> std.string const &
def | setGlobalParameterName
| setGlobalParameterName(CustomHbondForce self, int index, std.string const & name)
def | getGlobalParameterDefaultValue
| getGlobalParameterDefaultValue(CustomHbondForce self, int index) -> double
def | setGlobalParameterDefaultValue
| setGlobalParameterDefaultValue(CustomHbondForce self, int index, double defaultValue)
def | addDonor
| addDonor(CustomHbondForce self, int d1, int d2, int d3, vectord parameters) -> int
def | getDonorParameters
| getDonorParameters(CustomHbondForce self, int index)
def | setDonorParameters
| setDonorParameters(CustomHbondForce self, int index, int d1, int d2, int d3, vectord parameters)
def | addAcceptor
| addAcceptor(CustomHbondForce self, int a1, int a2, int a3, vectord parameters) -> int
def | getAcceptorParameters
| getAcceptorParameters(CustomHbondForce self, int index)
def | setAcceptorParameters
| setAcceptorParameters(CustomHbondForce self, int index, int a1, int a2, int a3, vectord parameters)
def | addExclusion
| addExclusion(CustomHbondForce self, int donor, int acceptor) -> int
def | getExclusionParticles
| getExclusionParticles(CustomHbondForce self, int index)
def | setExclusionParticles
| setExclusionParticles(CustomHbondForce self, int index, int donor, int acceptor)
def | addTabulatedFunction
| addTabulatedFunction(CustomHbondForce self, std.string const & name, TabulatedFunction function) -> int
def | getTabulatedFunction
| getTabulatedFunction(CustomHbondForce self, int index) -> TabulatedFunction getTabulatedFunction(CustomHbondForce self, int index) -> TabulatedFunction
def | getTabulatedFunctionName
| getTabulatedFunctionName(CustomHbondForce self, int index) -> std.string const &
def | addFunction
| addFunction(CustomHbondForce self, std.string const & name, vectord values, double min, double max) -> int
def | getFunctionParameters
| getFunctionParameters(CustomHbondForce self, int index)
def | setFunctionParameters
| setFunctionParameters(CustomHbondForce self, int index, std.string const & name, vectord values, double min, double max)
def | updateParametersInContext
| updateParametersInContext(CustomHbondForce self, Context context)
def | __init__
| __init__(OpenMM.CustomHbondForce self, std.string const & energy) -> CustomHbondForce __init__(OpenMM.CustomHbondForce self, CustomHbondForce other) -> CustomHbondForce
## Public Attributes
| this
## Static Public Attributes
| NoCutoff = _openmm.CustomHbondForce_NoCutoff
| CutoffNonPeriodic = _openmm.CustomHbondForce_CutoffNonPeriodic
| CutoffPeriodic = _openmm.CustomHbondForce_CutoffPeriodic

## Detailed Description

This class supports a wide variety of energy functions used to represent hydrogen bonding.

It computes interactions between "donor" particle groups and "acceptor" particle groups, where each group may include up to three particles. Typically a donor group consists of a hydrogen atom and the atoms it is bonded to, and an acceptor group consists of a negatively charged atom and the atoms it is bonded to.

We refer to the particles in a donor group as d1, d2 and d3, and the particles in an acceptor group as a1, a2, and a3. For each donor and each acceptor, CustomHbondForce evaluates a user supplied algebraic expression to determine the interaction energy. The expression may depend on arbitrary distances, angles, and dihedral angles defined by any of the six particles involved. The function distance(p1, p2) is the distance between the particles p1 and p2 (where "p1" and "p2" should be replaced by the names of the actual particles to calculate the distance between), angle(p1, p2, p3) is the angle formed by the three specified particles, and dihedral(p1, p2, p3, p4) is the dihedral angle formed by the four specified particles.

The expression also may involve tabulated functions, and may depend on arbitrary global, per-donor, and per-acceptor parameters. It also optionally supports periodic boundary conditions and cutoffs for long range interactions.

To use this class, create a CustomHbondForce object, passing an algebraic expression to the constructor that defines the interaction energy between each donor and acceptor. Then call addPerDonorParameter() to define per-donor parameters, addPerAcceptorParameter() to define per-acceptor parameters, and addGlobalParameter() to define global parameters. The values of per-donor and per-acceptor parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context.setParameter().

Next, call addDonor() and addAcceptor() to define donors and acceptors and specify their parameter values. After a donor or acceptor has been added, you can modify its parameters by calling setDonorParameters() or setAcceptorParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

CustomHbondForce also lets you specify "exclusions", particular combinations of donors and acceptors whose interactions should be omitted from force and energy calculations. This is most often used for particles that are bonded to each other.

As an example, the following code creates a CustomHbondForce that implements a simple harmonic potential to keep the distance between a1 and d1, and the angle formed by a1-d1-d2, near ideal values:

`CustomHbondForce* force = new CustomHbondForce("k*(distance(a1,d1)-r0)^2*(angle(a1,d1,d2)-theta0)^2");`

This force depends on three parameters: k, r0, and theta0. The following code defines these as per-donor parameters:

``

    force->addPerDonorParameter("k");
    force->addPerDonorParameter("r0");
    force->addPerDonorParameter("theta0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

In addition, you can call addTabulatedFunction() to define a new function based on tabulated values. You specify the function by creating a TabulatedFunction object. That function can then appear in the expression.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(OpenMM.CustomHbondForce self)

Reimplemented from Force.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(OpenMM.CustomHbondForce self, std.string const & energy) -> CustomHbondForce __init__(OpenMM.CustomHbondForce self, CustomHbondForce other) -> CustomHbondForce

Create a CustomHbondForce.

Parameters:

  | energy | an algebraic expression giving the interaction energy between a donor and an acceptor as a function of inter-particle distances, angles, and dihedrals, as well as any global, per-donor, and per-acceptor parameters

def addAcceptor | ( |  | self,
|  |  | args |
| ) |  |  |

addAcceptor(CustomHbondForce self, int a1, int a2, int a3, vectord parameters) -> int

Add an acceptor group to the force

Parameters:

  | a1 | the index of the first particle for this acceptor group
  | a2 | the index of the second particle for this acceptor group. If the group only includes one particle, this must be -1.
  | a3 | the index of the third particle for this acceptor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-acceptor parameter values for the new acceptor

def addDonor | ( |  | self,
|  |  | args |
| ) |  |  |

addDonor(CustomHbondForce self, int d1, int d2, int d3, vectord parameters) -> int

Add a donor group to the force

Parameters:

  | d1 | the index of the first particle for this donor group
  | d2 | the index of the second particle for this donor group. If the group only includes one particle, this must be -1.
  | d3 | the index of the third particle for this donor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-donor parameter values for the new donor

def addExclusion | ( |  | self,
|  |  | args |
| ) |  |  |

addExclusion(CustomHbondForce self, int donor, int acceptor) -> int

Add a donor-acceptor pair to the list of interactions that should be excluded.

Parameters:

  | donor | the index of the donor to exclude
  | acceptor | the index of the acceptor to exclude

def addFunction | ( |  | self,
|  |  | args |
| ) |  |  |

addFunction(CustomHbondForce self, std.string const & name, vectord values, double min, double max) -> int

Add a tabulated function that may appear in the energy expression.

def addGlobalParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addGlobalParameter(CustomHbondForce self, std.string const & name, double defaultValue) -> int

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

def addPerAcceptorParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addPerAcceptorParameter(CustomHbondForce self, std.string const & name) -> int

Add a new per-acceptor parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

def addPerDonorParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addPerDonorParameter(CustomHbondForce self, std.string const & name) -> int

Add a new per-donor parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

def addTabulatedFunction | ( |  | self,
|  |  | args |
| ) |  |  |

addTabulatedFunction(CustomHbondForce self, std.string const & name, TabulatedFunction function) -> int

Add a tabulated function that may appear in the energy expression.

Parameters:

  | name | the name of the function as it appears in expressions
  | function | a TabulatedFunction object defining the function. The TabulatedFunction should have been created on the heap with the "new" operator. The Force takes over ownership of it, and deletes it when the Force itself is deleted.

def getAcceptorParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getAcceptorParameters(CustomHbondForce self, int index)

Get the properties of an acceptor group.

Parameters:

  | index | the index of the acceptor group to get
  | a1 | the index of the first particle for this acceptor group
  | a2 | the index of the second particle for this acceptor group. If the group only includes one particle, this will be -1.
  | a3 | the index of the third particle for this acceptor group. If the group includes less than three particles, this will be -1.
  | parameters | the list of per-acceptor parameter values for the acceptor

def getCutoffDistance | ( |  | self | ) |

getCutoffDistance(CustomHbondForce self) -> double

Get the cutoff distance (in nm) being used. All interactions for which the distance between d1 and a1 is greater than the cutoff will be ignored. If the NonbondedMethod in use is NoCutoff, this value will have no effect.

def getDonorParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getDonorParameters(CustomHbondForce self, int index)

Get the properties of a donor group.

Parameters:

  | index | the index of the donor group to get
  | d1 | the index of the first particle for this donor group
  | d2 | the index of the second particle for this donor group. If the group only includes one particle, this will be -1.
  | d3 | the index of the third particle for this donor group. If the group includes less than three particles, this will be -1.
  | parameters | the list of per-donor parameter values for the donor

def getEnergyFunction | ( |  | self | ) |

getEnergyFunction(CustomHbondForce self) -> std.string const &

Get the algebraic expression that gives the interaction energy between a donor and an acceptor

def getExclusionParticles | ( |  | self,
|  |  | args |
| ) |  |  |

getExclusionParticles(CustomHbondForce self, int index)

Get the donor and acceptor in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to get donor and acceptor indices
  | particle1 | the index of the donor
  | particle2 | the index of the acceptor

def getFunctionParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getFunctionParameters(CustomHbondForce self, int index)

Get the parameters for a tabulated function that may appear in the energy expression.

def getGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterDefaultValue(CustomHbondForce self, int index) -> double

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

def getGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterName(CustomHbondForce self, int index) -> std.string const &

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getNonbondedMethod | ( |  | self | ) |

getNonbondedMethod(CustomHbondForce self) -> OpenMM.CustomHbondForce.NonbondedMethod

Get the method used for handling long range nonbonded interactions.

def getNumAcceptors | ( |  | self | ) |

getNumAcceptors(CustomHbondForce self) -> int

Get the number of acceptors for which force field parameters have been defined.

def getNumDonors | ( |  | self | ) |

getNumDonors(CustomHbondForce self) -> int

Get the number of donors for which force field parameters have been defined.

def getNumExclusions | ( |  | self | ) |

getNumExclusions(CustomHbondForce self) -> int

Get the number of donor-acceptor pairs whose interactions should be excluded.

def getNumFunctions | ( |  | self | ) |

getNumFunctions(CustomHbondForce self) -> int

Get the number of tabulated functions that have been defined.

def getNumGlobalParameters | ( |  | self | ) |

getNumGlobalParameters(CustomHbondForce self) -> int

Get the number of global parameters that the interaction depends on.

def getNumPerAcceptorParameters | ( |  | self | ) |

getNumPerAcceptorParameters(CustomHbondForce self) -> int

Get the number of per-acceptor parameters that the interaction depends on.

def getNumPerDonorParameters | ( |  | self | ) |

getNumPerDonorParameters(CustomHbondForce self) -> int

Get the number of per-donor parameters that the interaction depends on.

def getNumTabulatedFunctions | ( |  | self | ) |

getNumTabulatedFunctions(CustomHbondForce self) -> int

Get the number of tabulated functions that have been defined.

def getPerAcceptorParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getPerAcceptorParameterName(CustomHbondForce self, int index) -> std.string const &

Get the name of a per-acceptor parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getPerDonorParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getPerDonorParameterName(CustomHbondForce self, int index) -> std.string const &

Get the name of a per-donor parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getTabulatedFunction | ( |  | self,
|  |  | args |
| ) |  |  |

getTabulatedFunction(CustomHbondForce self, int index) -> TabulatedFunction getTabulatedFunction(CustomHbondForce self, int index) -> TabulatedFunction

Get a reference to a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

def getTabulatedFunctionName | ( |  | self,
|  |  | args |
| ) |  |  |

getTabulatedFunctionName(CustomHbondForce self, int index) -> std.string const &

Get the name of a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

def setAcceptorParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setAcceptorParameters(CustomHbondForce self, int index, int a1, int a2, int a3, vectord parameters)

Set the properties of an acceptor group.

Parameters:

  | index | the index of the acceptor group to set
  | a1 | the index of the first particle for this acceptor group
  | a2 | the index of the second particle for this acceptor group. If the group only includes one particle, this must be -1.
  | a3 | the index of the third particle for this acceptor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-acceptor parameter values for the acceptor

def setCutoffDistance | ( |  | self,
|  |  | args |
| ) |  |  |

setCutoffDistance(CustomHbondForce self, double distance)

Set the cutoff distance (in nm) being used. All interactions for which the distance between d1 and a1 is greater than the cutoff will be ignored. If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Parameters:

  | distance | the cutoff distance, measured in nm

def setDonorParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setDonorParameters(CustomHbondForce self, int index, int d1, int d2, int d3, vectord parameters)

Set the properties of a donor group.

Parameters:

  | index | the index of the donor group to set
  | d1 | the index of the first particle for this donor group
  | d2 | the index of the second particle for this donor group. If the group only includes one particle, this must be -1.
  | d3 | the index of the third particle for this donor group. If the group includes less than three particles, this must be -1.
  | parameters | the list of per-donor parameter values for the donor

def setEnergyFunction | ( |  | self,
|  |  | args |
| ) |  |  |

setEnergyFunction(CustomHbondForce self, std.string const & energy)

Set the algebraic expression that gives the interaction energy between a donor and an acceptor

def setExclusionParticles | ( |  | self,
|  |  | args |
| ) |  |  |

setExclusionParticles(CustomHbondForce self, int index, int donor, int acceptor)

Get the donor and acceptor in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to get donor and acceptor indices
  | particle1 | the index of the donor
  | particle2 | the index of the acceptor

def setFunctionParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setFunctionParameters(CustomHbondForce self, int index, std.string const & name, vectord values, double min, double max)

Set the parameters for a tabulated function that may appear in the energy expression.

def setGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterDefaultValue(CustomHbondForce self, int index, double defaultValue)

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

def setGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterName(CustomHbondForce self, int index, std.string const & name)

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def setNonbondedMethod | ( |  | self,
|  |  | args |
| ) |  |  |

setNonbondedMethod(CustomHbondForce self, OpenMM.CustomHbondForce.NonbondedMethod method)

Set the method used for handling long range nonbonded interactions.

def setPerAcceptorParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setPerAcceptorParameterName(CustomHbondForce self, int index, std.string const & name)

Set the name of a per-acceptor parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def setPerDonorParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setPerDonorParameterName(CustomHbondForce self, int index, std.string const & name)

Set the name of a per-donor parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def updateParametersInContext | ( |  | self,
|  |  | args |
| ) |  |  |

updateParametersInContext(CustomHbondForce self, Context context)

Update the per-donor and per-acceptor parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setDonorParameters() and setAcceptorParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-donor and per-acceptor parameters. All other aspects of the Force (the energy function, nonbonded method, cutoff distance, etc.) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a donor or acceptor cannot be changed, nor can new donors or acceptors be added.

## Member Data Documentation

CutoffNonPeriodic = _openmm.CustomHbondForce_CutoffNonPeriodic`[static]`

CutoffPeriodic = _openmm.CustomHbondForce_CutoffPeriodic`[static]`

NoCutoff = _openmm.CustomHbondForce_NoCutoff`[static]`

this

The documentation for this class was generated from the following file:

- openmm.py